VoximplantAPI

View as Markdown

Classes

Types

A2PGetSmsHistoryRequest

count
number

optional

Maximum number of resulting rows fetched. Must be not bigger than 1000. If left blank, then the default value of 1000 is used

deliveryStatus
number

optional

The delivery status ID: QUEUED - 1, DISPATCHED - 2, ABORTED - 3, REJECTED - 4, DELIVERED - 5, FAILED - 6, EXPIRED - 7, UNKNOWN - 8

destinationNumber
string

optional

The destination phone number

fromDate
Date

optional

Date from which the search is to start. Format is ‘yyyy-MM-dd HH:mm:ss’, time zone is UTC

offset
number

optional

The first N records are skipped in the output

output
string

optional

The output format. The following values available: json, csv, xls. The default value is json

sourceNumber
string

optional

The source phone number

toDate
Date

optional

Date from which the search is to end. Format is ‘yyyy-MM-dd HH:mm:ss’, time zone is UTC

A2PGetSmsHistoryResponse

error
APIError

optional

result
A2PSmsHistory[]
totalCount
number

Total number of messages matching the query parameters

A2PSendSmsRequest

dstNumbers
string | string[]

The destination phone numbers separated by semicolons (;). The maximum number of these phone numbers is 100

srcNumber
string

The SenderID for outgoing SMS. Please contact support for installing a SenderID

storeBody
boolean

optional

Whether to store outgoing message texts. Default value is false

text
string

The message text, up to 1600 characters. We split long messages greater than 160 GSM-7 characters or 70 UTF-16 characters into multiple segments. Each segment is charged as one message

A2PSendSmsResponse

error
APIError

optional

failed
FailedSms[]
fragmentsCount
number

The number of fragments the message is divided into

result
SmsTransaction[]

A2PSmsHistory

cost
number

The message cost

deliveryStatus
string

Delivery status: QUEUED, DISPATCHED, ABORTED, REJECTED, DELIVERED, FAILED, EXPIRED, UNKNOWN

destinationNumber
number

SMS destination number

errorMessage
string

optional

Error message (if any)

fragments
number

Number of fragments the initial message is divided into

messageId
number

Message ID

processingDate
Date

Date of message processing. The format is yyyy-MM-dd HH:mm:ss

sourceNumber
number

SMS source number

statusId
string

The message status. The possible values are: 1 — Success, 2 — Error, 3 — Waiting

text
string

optional

Stored message text

transactionId
number

The transaction ID for this message

AccountInfo

a2pSmsEnabled
boolean

optional

Whether to activate one-way SMS

accessEntries
string[]

optional

The allowed access entries (the API function names)

accountCustomData
string

optional

The custom data

accountEmail
string

The account’s email

accountFirstName
string

optional

The first name

accountId
number

The account’s ID

accountLastName
string

optional

The last name

accountName
string

The account’s name

accountNotifications
boolean

optional

Whether Voximplant notifications are required

active
boolean

Whether the account is active

apiKey
string

optional

The account API key. Use password or api_key authentication to show the api_key

balance
number

optional

The account’s money

billingAddressAddress
string

optional

The office address

billingAddressCountryCode
string

optional

The billing address country code (2 symbols, ISO 3166-1 alpha-2). Examples: US, RU, GB

billingAddressName
string

optional

The company or businessman name

billingAddressPhone
string

optional

The office phone number

billingAddressState
string

optional

The office state (US) or province (Canada), up to 100 characters. Examples: California, Illinois, British Columbia

billingAddressZip
string

optional

The office ZIP

billingLimits
BillingLimits

optional

The payments limits applicable to each payment method

callbackSalt
string

optional

If salt string is specified, each HTTP request made by the Voximplant cloud toward the callback_url has a salt field set to MD5 hash of account information and salt. That hash can be used be a developer to ensure that HTTP request is made by the Voximplant cloud

callbackUrl
string

optional

If URL is specified, Voximplant cloud makes HTTP POST requests to it when something happens. For a full list of reasons see the type field of the AccountCallback structure. The HTTP request has a JSON-encoded body that conforms to the AccountCallbacks structure

created
Date

The UTC account created time in 24-h format: YYYY-MM-DD HH:mm:ss

creditLimit
number

optional

The account’s credit limit

currency
string

optional

The currency code (USD, RUR, EUR, …)

frozen
boolean

optional

Whether account is blocked by Voximplant admins

languageCode
string

optional

The notification language code (2 symbols, ISO639-1). Examples: en, ru

location
string

optional

The account location (timezone). Examples: America/Los_Angeles, Etc/GMT-8, Etc/GMT+10

minBalanceToNotify
number

optional

The min balance value to notify by email or SMS

newsNotifications
boolean

optional

Whether Voximplant news notifications are required

sendJsError
boolean

optional

Whether to send an email when a JS error occurs

supportBankCard
boolean

optional

Whether Bank card payments are allowed

supportInvoice
boolean

optional

Whether Bank invoices are allowed

supportRobokassa
boolean

optional

Whether Robokassa payments are allowed

tariffChangingNotifications
boolean

optional

Whether Voximplant plan changing notifications are required

withAccessEntries
boolean

optional

Whether the admin user permissions are granted

AccountInvoice

amount
InvoiceTotalDetails

Info on all money spent in the invoice

invoiceDate
Date

Date when the invoice is created in the following format: YYYY-MM-DD

invoiceId
number

Invoice id

invoiceNumber
string

Unique invoice number

period
InvoicePeriod

Invoice period

rows
InvoiceSpendingDetails

Detailed info on each spending

status
string

Invoice status

AccountsInterface

getAccountInfo
(request: GetAccountInfoRequest) => Promise<GetAccountInfoResponse>

Gets the account’s info such as account_id, account_name, account_email etc.

getCurrencyRate
(request: GetCurrencyRateRequest) => Promise<GetCurrencyRateResponse>

Gets the exchange rate on selected date (per USD).

ACDAfterServiceOperatorState

status
string

optional

The operator status string

userDisplayName
string

The display user name of the operator

userId
number

The user ID of the operator

userName
string

The user name of the operator

ACDLock

created
Date

The UTC lock created time in 24-h format: YYYY-MM-DD HH:mm:ss

id
string

The ACD lock ID

ACDLockedOperatorState

acdCalls
ACDOperatorCall[]

optional

The ACD operator calls

locks
ACDLock[]

optional

The operator locks

status
string

optional

The operator status string. ‘BANNED’ string indicates temporarily banned operators. The following values are possible: READY, BANNED

unreached
Date

optional

The UTC time when the operator becomes unavailable in 24-h format: YYYY-MM-DD HH:mm:ss

userDisplayName
string

The display user name of the operator

userId
number

The user ID of the operator

userName
string

The user name of the operator

ACDOperatorCall

acdQueueId
number

The ACD queue ID

acdQueueName
string

The ACD queue name

acdRequestId
string

The internal ACD session history ID

acdSessionHistoryId
number

The ACD session history ID of the request

beginTime
Date

The begin time of the request in 24-h format: YYYY-MM-DD HH:mm:ss

callerid
string

optional

The client callerid

submitted
Date

optional

The submission time of the request in 24-h format: YYYY-MM-DD HH:mm:ss

ACDQueueOperatorInfo

acdQueueId
number

The ACD queue ID

acdQueueName
string

The ACD queue name

autoLink
boolean

Whether the user is bound to the ACD queue in manual mode if false

ACDQueueState

acdQueueId
number

The ACD queue ID

afterServiceOperatorCount
number

Number of operators with the ‘AFTER SERVICE’ state

afterServiceOperators
ACDAfterServiceOperatorState[]

List of operators with the ‘AFTER_SERVICE’ state. This state is set right after a call is ended to indicate a call postprocessing

lockedOperators
ACDLockedOperatorState[]

List of operators with the ‘READY’ state that cannot accept a call from this queue. Operator cannot accept a call if they are temporarily banned, or they are servicing a call right now

lockedOperatorsCount
number

Number of locked operators

readyOperators
ACDReadyOperatorState[]

List of operators with the ‘READY’ state that can accept a call from this queue

readyOperatorsCount
number

Number of ready operators

servicingCalls
ACDServicingCallState[]

List of calls enqueued into this queue that are being serviced right now by operators

waitingCalls
ACDWaitingCallState[]

List of calls enqueued into this queue that are not yet serviced by operators

ACDReadyOperatorState

idleDuration
number

The idle duration in seconds. The minimum of the duration after the last hangup and the duration after the operator status changing to READY

userDisplayName
string

The display user name of the operator

userId
number

The user ID of the operator

userName
string

The user name of the operator

ACDServicingCallState

acdSessionHistoryId
number

The ACD session history ID of the request

beginTime
Date

The begin time of the request in 24-h format: YYYY-MM-DD HH:mm:ss

callerid
string

optional

The client callerid

priority
number

The request priority

userDisplayName
string

The display user name of the operator

userId
number

The user ID of the operator

userName
string

The user name of the operator

waitingTime
number

The waiting time before servicing in seconds

ACDState

acdQueues
ACDQueueState[]

The queues’ states

ACDWaitingCallState

acdSessionHistoryId
number

The ACD session history ID of the request

beginTime
Date

The begin time of the request in 24-h format: YYYY-MM-DD HH:mm:ss

callerid
string

optional

The client callerid

minutesToSubmit
number

The predicted minutes left to start servicing

priority
number

The request priority

userDisplayName
string

The display user name of the operator

userId
number

optional

The user ID of the operator to try to service the request

userName
string

The user name of the operator

waitingTime
number

The waiting time in seconds

ActivateOutboundTestPhoneNumberRequest

verificationCode
string

The verification code, see the VerifyOutboundTestPhoneNumber function

ActivateOutboundTestPhoneNumberResponse

error
APIError

optional

result
number

Returns 1 if the request has been completed successfully

AddAdminRoleRequest

adminRoleActive
boolean

optional

Whether the admin role is enabled. If false the allowed and denied entries have no affect

adminRoleName
string

The admin role name. The length must be less than 50

allowedEntries
string | string[]

optional

The list of allowed access entries separated by semicolons (;) (the API function names)

deniedEntries
string | string[]

optional

The list of denied access entries separated by semicolons (;) (the API function names)

likeAdminRoleId
'any' | number | number[]

optional

The admin role ID list separated by semicolons (;). Use the ‘all’ value to select all admin roles. The list specifies the roles from which the new role automatically copies all permissions (allowed_entries and denied_entries)

likeAdminRoleName
string | string[]

optional

The admin role name that can be used instead of like_admin_role_id. The name specifies a role from which the new role automatically copies all permissions (allowed_entries and denied_entries)

AddAdminRoleResponse

adminRoleId
number

The new admin role ID

error
APIError

optional

result
number

Returns 1 if the request has been completed successfully

AddAdminUserRequest

adminRoleId
string

optional

The role(s) ID created via Managing Admin Roles methods. The attaching admin role ID list separated by semicolons (;). Use the ‘all’ value to select all admin roles

adminRoleName
string | string[]

optional

The role(s) name(s) created via Managing Admin Roles methods. The attaching admin role name that can be used instead of admin_role_id

adminUserActive
boolean

optional

Whether the admin user is active

adminUserDisplayName
string

The admin user display name. The length must be less than 256

newAdminUserName
string

The admin user name. The length must be less than 50

newAdminUserPassword
string

The admin user password. The length must be at least 6 symbols

AddAdminUserResponse

adminUserApiKey
string

The admin user API key

adminUserId
number

The new admin user ID

error
APIError

optional

result
number

Returns 1 if the request has been completed successfully

AddApplicationRequest

applicationName
string

Short application name in the [a-z][a-z0-9-]{1,64} format

secureRecordStorage
boolean

optional

Whether to enable secure storage for all logs and records of the application

AddApplicationResponse

applicationId
number

The application ID

applicationName
string

The full application name

error
APIError

optional

result
number

Returns 1 if the request has been completed successfully

secureRecordStorage
boolean

Whether a secure storage for logs and records is enabled or not

AddAuthorizedAccountIPRequest

allowed
boolean

optional

Whether to remove the IP from the blacklist

authorizedIp
string

The authorized IP4 or network

description
string

optional

The IP address description

AddAuthorizedAccountIPResponse

error
APIError

optional

result
number

Returns 1 if the request has been completed successfully

AddOutboundTestPhoneNumberRequest

phoneNumber
string

The personal phone number in the E.164 format

AddOutboundTestPhoneNumberResponse

error
APIError

optional

result
number

Returns 1 if the request has been completed successfully

AddPstnBlackListItemRequest

pstnBlacklistPhone
string

The phone number in format e164 or regex pattern

AddPstnBlackListItemResponse

error
APIError

optional

pstnBlacklistId
number

The PSTN black list item ID

result
number

Returns 1 if the request has been completed successfully

AddQueueRequest

acdQueueName
string

The queue name. The length must be less than 100

acdQueuePriority
number

optional

The integer queue priority. The highest priority is 0

applicationId
number

The application ID

applicationName
string

The application name that can be used instead of application_id

autoBinding
boolean

optional

Whether to enable the auto binding of operators to a queue by skills comparing

averageServiceTime
number

optional

The average service time in seconds. Specify the parameter to correct or initialize the waiting time prediction

maxQueueSize
number

optional

The max queue size

maxWaitingTime
number

optional

The max predicted waiting time in minutes. The client is rejected if the predicted waiting time is greater than the max predicted waiting time

serviceProbability
number

optional

The value in the range of [0.5 … 1.0]. The value 1.0 means the service probability 100% in challenge with a lower priority queue

AddQueueResponse

acdQueueId
number

The ACD queue ID

error
APIError

optional

result
number

Returns 1 if the request has been completed successfully

AddSecretRequest

applicationId
number

Application ID to add the secret to

applicationName
string

Application name. Can be used instead of application_id

description
string

optional

Optional. Secret description. When processing, the length is truncated to the first 200 characters

secretName
string

Secret name. The name must start with a Latin letter and can contain up to 64 characters, including Latin letters, digits and underscores

secretValue
string

Secret value. Maximum length is 8192 characters

AddSecretResponse

error
APIError

optional

result
AddSecretResult[]

Result with the added secret ID

AddSecretResult

secretId
number

Added secret ID

AddSipWhiteListItemRequest

description
string

optional

The network address description

sipWhitelistNetwork
string

The network address in format A.B.C.D/L or A.B.C.D/a.b.c.d (example 192.168.1.5/16)

AddSipWhiteListItemResponse

error
APIError

optional

result
number

Returns 1 if the request has been completed successfully

sipWhitelistId
number

The SIP white list item ID

AddSkillRequest

skillName
string

The ACD operator skill name. The length must be less than 512

AddSkillResponse

error
APIError

optional

result
number

Returns 1 if the request has been completed successfully

skillId
number

The skill ID

AddUserRequest

applicationId
number

The application ID which a new user is to be bound to. Can be used instead of the application_name parameter

applicationName
string

The application name which a new user is to be bound to. Can be used instead of the application_id parameter

mobilePhone
string

optional

parentAccounting
boolean

optional

Whether the user uses the parent account’s money, ‘false’ if the user has a separate balance

userActive
boolean

optional

Whether the user is active. Inactive users cannot log in to applications

userCustomData
string

optional

Any string

userDisplayName
string

The user display name. The length must be less than 256

userName
string

The user name in format [a-z0-9][a-z0-9_-]{2,49}

userPassword
string

The user password. Must be at least 8 characters long and contain at least one uppercase and lowercase letter, one number, and one special character

AddUserResponse

error
APIError

optional

result
number

Returns 1 if the request has been completed successfully

userId
number

The new user ID

AdminRole

adminRoleActive
boolean

Whether to ignore the allowed and denied entries

adminRoleId
number

The admin role ID

adminRoleName
string

The admin role name

allowedEntries
string[]

optional

The allowed access entries (the API function names)

deniedEntries
string[]

optional

The denied access entries (the API function names)

modified
Date

The admin role editing UTC date in 24-h format: YYYY-MM-DD HH:mm:ss

systemRole
boolean

Whether it is a system role

AdminRolesInterface

addAdminRole
(request: AddAdminRoleRequest) => Promise<AddAdminRoleResponse>

Adds a new admin role.

delAdminRole
(request: DelAdminRoleRequest) => Promise<DelAdminRoleResponse>

Deletes the specified admin role.

getAdminRoles
(request: GetAdminRolesRequest) => Promise<GetAdminRolesResponse>

Gets the admin roles.

getAvailableAdminRoleEntries
(\n request: GetAvailableAdminRoleEntriesRequest\n ) => Promise<GetAvailableAdminRoleEntriesResponse>

Gets the all available admin role entries.

setAdminRoleInfo
(request: SetAdminRoleInfoRequest) => Promise<SetAdminRoleInfoResponse>

Edits the specified admin role.

AdminUser

accessEntries
string[]

optional

The allowed access entries (the API function names)

adminRoles
AdminRole[]

optional

The attached admin roles

adminUserActive
boolean

Whether login is allowed

adminUserDisplayName
string

The admin user display name

adminUserId
number

The admin user ID

adminUserName
string

The admin user name

modified
Date

The admin user editing UTC date in 24-h format: YYYY-MM-DD HH:mm:ss

AdminUsersInterface

addAdminUser
(request: AddAdminUserRequest) => Promise<AddAdminUserResponse>

Adds a new admin user into the specified parent or child account.

attachAdminRole
(request: AttachAdminRoleRequest) => Promise<AttachAdminRoleResponse>

Attaches the admin role(s) to the already existing admin(s).

delAdminUser
(request: DelAdminUserRequest) => Promise<DelAdminUserResponse>

Deletes the specified admin user.

getAdminUsers
(request: GetAdminUsersRequest) => Promise<GetAdminUsersResponse>

Gets the admin users of the specified account. Note that both account types - parent and child - can have its own admins.

setAdminUserInfo
(request: SetAdminUserInfoRequest) => Promise<SetAdminUserInfoResponse>

Edits the specified admin user.

APIError

code
number

The error code

msg
string

The error description

AppendToCallListRequest

delimiter
string

optional

Separator values. The default value is ’;’

encoding
string

optional

Encoding file. The default value is UTF-8

escape
string

optional

Escape character for parsing csv

fileContent
Buffer

Send as the request body or multiform

listId
number

Call list ID

listName
string

AppendToCallListResponse

batchId
number

Batch UUID

count
number

Number of stored records

error
APIError

optional

listId
number

List ID

result
boolean

Whether the request completed successfully

ApplicationInfo

applicationId
number

The application ID

applicationName
string

The full application name

modified
Date

The application editing UTC date in 24-h format: YYYY-MM-DD HH:mm:ss

secureRecordStorage
boolean

Whether a secure storage for logs and records is enabled

ApplicationsInterface

addApplication
(request: AddApplicationRequest) => Promise<AddApplicationResponse>

Adds a new account’s application.

delApplication
(request: DelApplicationRequest) => Promise<DelApplicationResponse>

Deletes the account’s application.

getApplications
(request: GetApplicationsRequest) => Promise<GetApplicationsResponse>

Gets the account’s applications.

setApplicationInfo
(request: SetApplicationInfoRequest) => Promise<SetApplicationInfoResponse>

Edits the account’s application.

AttachAdminRoleRequest

adminRoleId
'any' | number | number[]

The role(s) ID created via Managing Admin Roles methods. The attached admin role ID list separated by semicolons (;). Use the ‘all’ value to select alladmin roles

adminRoleName
string | string[]

The role(s) name(s) created via Managing Admin Roles methods. The admin role name to attach, can be used instead of admin_role_id

mode
string

optional

The merge mode. The following values are possible: add, del, set

requiredAdminUserId
'any' | number | number[]

The admin user ID list separated by semicolons (;). Use the ‘all’ value to select all admin users

requiredAdminUserName
string | string[]

The admin user name to bind, can be used instead of required_admin_user_id

AttachAdminRoleResponse

error
APIError

optional

result
number

Returns 1 if the request has been completed successfully

AttachedPhoneInfo

activationStatus
string

optional

Phone number activation status

applicationId
number

optional

ID of the bound application

applicationName
string

optional

Name of the bound application

autoCharge
boolean

Whether to charge automatically

canBeUsed
boolean

Whether a not verified account can use the phone

canceled
boolean

Whether the subscription is cancelled

categoryName
string

The phone category name (MOBILE, GEOGRAPHIC, TOLLFREE, MOSCOW495)

deactivated
boolean

Whether the subscription is frozen

emergencyCallsEnabled
boolean

Whether calls to emergency numbers are enabled

emergencyCallsToBeEnabled
boolean

Whether you need to make a request to enable calls to emergency numbers

extendedApplicationName
string

optional

Full application name, e.g. myapp.myaccount.n1.voximplant.com

incomingSmsCallbackUrl
string

optional

If set, the callback of an incoming SMS is sent to this url, otherwise, it is sent to the general account URL

isSmsEnabled
boolean

Whether SMS sending and receiving is enabled for this phone number via the ControlSms Management API

isSmsSupported
boolean

Whether SMS is supported for this phone number. SMS needs to be explicitly enabled via the ControlSms Management API before sending or receiving SMS. If SMS is supported and enabled, SMS can be sent from this phone number via the SendSmsMessage Management API and received via the InboundSmsCallback property of the HTTP callback. See this article for HTTP callback details

modified
Date

UTC date of an event associated with the number in 24-h format: YYYY-MM-DD HH:mm:ss

phoneCountryCode
string

The phone country code (2 symbols)

phoneId
number

The phone ID

phoneNextRenewal
Date

The next renewal date in the following format: YYYY-MM-DD

phoneNumber
string

The phone number

phonePrice
number

The phone monthly charge in the account’s currency

phonePurchaseDate
Date

The purchase date in 24-h format: YYYY-MM-DD HH:mm:ss

phoneRegionName
string

optional

Phone region name

requiredVerification
string

optional

Whether the verification is required for the account

ruleId
number

optional

ID of the bound rule

ruleName
string

optional

Name of the bound rule

subscriptionId
number

Phone number subscription ID

unverifiedHoldUntil
Date

optional

Unverified phone hold until the date in the following format: YYYY-MM-DD (if the account verification is required). The number is detached on that day automatically!

verificationStatus
string

optional

The account verification status. The following values are possible: REQUIRED, IN_PROGRESS, VERIFIED

AuthorizedAccountIP

allowed
boolean

Whether the IP is allowed (true - whitelist, false - blacklist)

authorizedIp
string

The authorized IP4 or network

created
Date

The item creating UTC date in 24-h format: YYYY-MM-DD HH:mm:ss

AuthorizedIPsInterface

addAuthorizedAccountIP
(\n request: AddAuthorizedAccountIPRequest\n ) => Promise<AddAuthorizedAccountIPResponse>

Adds a new authorized IP4 or network to the white/black list.

checkAuthorizedAccountIP
(\n request: CheckAuthorizedAccountIPRequest\n ) => Promise<CheckAuthorizedAccountIPResponse>

Tests whether the IP4 is banned or allowed.

delAuthorizedAccountIP
(\n request: DelAuthorizedAccountIPRequest\n ) => Promise<DelAuthorizedAccountIPResponse>

Removes the authorized IP4 or network from the white/black list.

getAuthorizedAccountIPs
(\n request: GetAuthorizedAccountIPsRequest\n ) => Promise<GetAuthorizedAccountIPsResponse>

Gets the authorized IP4 or network.

BankCardBillingLimitInfo

currency
string

The currency

minAmount
number

The minimum amount

BillingLimitInfo

currency
string

The currency

minAmount
number

The minimum amount

BillingLimits

bankCard
BankCardBillingLimitInfo

optional

The bank card limits

invoice
BillingLimitInfo

optional

The invoice limits

robokassa
BillingLimitInfo

optional

The Robokassa limits

BindSipRegistrationRequest

applicationId
number

optional

The application ID which the SIP registration is to be bound to. Can be used instead of the application_name parameter

applicationName
string

optional

The application name which the SIP registration is to be bound to. Can be used instead of the application_id parameter

bind
boolean

optional

Whether to bind or unbind (set true or false respectively)

ruleId
number

optional

The rule ID which the SIP registration is to be bound to. Can be used instead of the rule_name parameter

ruleName
string

optional

The rule name which the SIP registration is to be bound to. Can be used instead of the rule_id parameter

sipRegistrationId
number

optional

The registration ID

userId
number

optional

The user ID which the SIP registration is to be bound to. Can be used instead of the user_name parameter

userName
string

optional

The user name which the SIP registration is to be bound to. Can be used instead of the user_id parameter

BindSipRegistrationResponse

error
APIError

optional

result
number

Returns 1 if the request has been completed successfully

BindSkillRequest

acdQueueId
'any' | number | number[]

The ACD queue ID list separated by semicolons (;). Use the ‘all’ value to select all ACD queues

acdQueueName
string | string[]

The ACD queue name that can be used instead of acd_queue_id. The ACD queue name list separated by semicolons (;)

applicationId
number

optional

The application ID. It is required if the user_name is specified

applicationName
string

optional

The application name that can be used instead of application_id

bind
boolean

optional

Whether to bind or unbind (set true or false respectively)

skillId
'any' | number | number[]

The skill ID list separated by semicolons (;). Use the ‘all’ value to select all skills

skillName
string | string[]

The skill name list separated by semicolons (;). Can be used instead of skill_id

userId
'any' | number | number[]

The user ID list separated by semicolons (;). Use the ‘all’ value to select all users

userName
string | string[]

The user name list separated by semicolons (;). user_name can be used instead of user_id

BindSkillResponse

error
APIError

optional

result
number

Returns 1 if the request has been completed successfully

BindUserToQueueRequest

acdQueueId
'any' | number | number[]

The ACD queue ID list separated by semicolons (;). Use the ‘all’ value to specify all queues bound to the application

acdQueueName
string | string[]

The queue name that can be used instead of acd_queue_id. The queue name list separated by semicolons (;)

applicationId
number

The application ID

applicationName
string

The application name that can be used instead of application_id

bind
boolean

Whether to bind or unbind users

userId
'any' | number | number[]

The user ID list separated by semicolons (;). Use the ‘all’ value to specify all users bound to the application

userName
string | string[]

The user name list separated by semicolons (;). user_name can be used instead of user_id

BindUserToQueueResponse

error
APIError

optional

result
number

Returns 1 if the request has been completed successfully

CallerIDInfo

active
boolean

Whether active

calleridId
number

The callerID id

calleridNumber
string

The callerID number

codeEnteringAttemptsLeft
number

optional

The code entering attempts left for the unverified callerID

verificationCallAttemptsLeft
number

optional

The verification call attempts left for the unverified callerID

verifiedUntil
Date

optional

The verification ending date in the following format: YYYY-MM-DD (for the verified callerID)

CallerIDsInterface

delCallerID
(request: DelCallerIDRequest) => Promise<DelCallerIDResponse>

Deletes the CallerID. Note: you cannot delete a CID permanently (the antispam defence).

getCallerIDs
(request: GetCallerIDsRequest) => Promise<GetCallerIDsResponse>

Gets the account callerIDs.

CallInfo

callId
number

Call’s history ID

cost
number

optional

Call’s cost

customData
string

optional

Custom data passed to the JS session

diversionNumber
string

optional

Call forwarding number

duration
number

optional

Call duration in seconds

endReason
any

optional

End reason code and description

incoming
boolean

Whether the call is incoming

localNumber
string

Local number on the platform side

mediaServerAddress
string

Media server’s IP address

recordUrl
string

optional

Record URL

remoteNumber
string

Remote number on the client side

remoteNumberType
string

Type of the remote number, e.g., a PSTN, mobile, user or sip address

startTime
Date

Call start time in the selected timezone in 24-h format: YYYY-MM-DD HH:mm:ss

successful
boolean

Whether the call is successful

transactionId
number

Transaction ID

CallList

dtComplete
Date

optional

The completion date in 24-h format: YYYY-MM-DD HH:mm:ss

dtSubmit
Date

The date of submitted the list in 24-h format: YYYY-MM-DD HH:mm:ss

intervalSeconds
number

The interval between attempts in seconds

listId
number

The list ID

listName
string

The list name

maxSimultaneous
number

The maximum number of simultaneous tasks

numAttempts
number

The number of task attempts run, which failed to call

priority
number

The priority of the call list

ruleId
number

The rule id

status
string

The status name. The possible values are In progress, Completed, Canceled

taskPriorityStrategy
string

Whether the first or repeated calls have priority.

CallListsInterface

appendToCallList
(request: AppendToCallListRequest) => Promise<AppendToCallListResponse>

Appends a new task to the existing call list. This method accepts CSV files with custom delimiters, such a commas (,), semicolons (;) and other. To specify a delimiter, pass it to the delimiter parameter.

cancelCallListBatch
(\n request: CancelCallListBatchRequest\n ) => Promise<CancelCallListBatchResponse>

Cancels all tasks in the call list with the specified batch UUID.

cancelCallListTask
(request: CancelCallListTaskRequest) => Promise<CancelCallListTaskResponse>

Cancels the specified tasks in the call list by their IDs or UUIDs. The maximum number of tasks to cancel is 1000.

createCallList
(request: CreateCallListRequest) => Promise<CreateCallListResponse>

Adds a new CSV file for call list processing and starts the specified rule immediately. To send a file, use the request body. To set the call time constraints, use the following options in a CSV file: __start_execution_time – when the call list processing starts every day, UTC+0 24-h format: HH:mm:ss__end_execution_time – when the call list processing stops every day, UTC+0 24-h format: HH:mm:ss__start_at – when the call list processing starts, UNIX timestamp. If not specified, the processing starts immediately after a method call__task_uuid – call list UUID. A string up to 40 characters, can contain latin letters, digits, hyphens (-) and colons (:). Unique within the call list This method accepts CSV files with custom delimiters, such a commas (,), semicolons (;) and other. To specify a delimiter, pass it to the delimiter parameter. IMPORTANT: the account’s balance should be equal or greater than 1 USD. If the balance is lower than 1 USD, the call list processing does not start, or it stops immediately if it is active.

deleteCallList
(request: DeleteCallListRequest) => Promise<DeleteCallListResponse>

Deletes an existing call list by its ID.

editCallList
(request: EditCallListRequest) => Promise<EditCallListResponse>

Edits the specified call list by its ID.

editCallListTasksPriority
(\n request: EditCallListTasksPriorityRequest\n ) => Promise<EditCallListTasksPriorityResponse>

Edits priorities of existing tasks in the specified call list.

getCallLists
(request: GetCallListsRequest) => Promise<GetCallListsResponse>

Get all call lists for the specified user.

CallSessionInfo

accountId
number

Account ID that initiates the JS session

applicationId
number

Application ID that initiates the JS session

applicationName
string

Application name

audioQuality
string

Call’s audio quality. The possible values are: Standard | HD | Ultra HD.

calls
CallInfo[]

optional

Calls within the JS session, including durations, cost, phone numbers and other information

callSessionHistoryId
number

Unique JS session identifier

customData
string

optional

Custom data

duration
number

optional

Entire JS session duration in seconds. The session can contain multiple calls

finishReason
string

optional

Finish reason. Possible values are Normal termination, Insufficient funds, Internal error (billing timeout), Terminated administratively, JS session error, Timeout

initiatorAddress
string

Initiator’s IP address

logFileUrl
string

Link to the session log. The log retention policy is 1 month, after that time this field clears. If you have issues accessing the log file, check if the application has “Secure storage of applications and logs” feature enabled. In this case, you need to authorize(/docs/guides/managementapi/secureobjects).

mediaServerAddress
string

Media server IP address

otherResourceUsage
ResourceUsage[]

optional

Used resources

records
Record[]

optional

Bound records

ruleName
string

Routing rule name

startDate
Date

Start date in the selected timezone in 24-h format: YYYY-MM-DD HH:mm:ss

userId
number

User ID that initiates the JS session

CancelCallListBatchRequest

batchIds
string

Batch UUIDs of the tasks to cancel, separated by semicolon (;)

listId
number

Call list ID

listName
string

CancelCallListBatchResponse

error
APIError

optional

result
boolean

Whether the request completed successfully

CancelCallListTaskRequest

accountId
string

Account’s ID

listId
string

Call list’s ID

tasksIds
string

optional

Task IDs separated by a semicolon. Specify either tasks_ids or tasks_uuids. The method returns an error if none of the parameters is specified

tasksUuids
string

optional

Task UUIDs separated by a semicolon. Specify either tasks_ids or tasks_uuids. The method returns an error if none of the parameters is specified

CancelCallListTaskResponse

error
APIError

optional

errorMsg
string

Reason for the error

result
boolean

Result of the operation

taskId
number

Task’s ID

taskUuid
string

Task’s UUID

CheckAuthorizedAccountIPRequest

authorizedIp
string

The IP4 to test

CheckAuthorizedAccountIPResponse

authorizedIp
string

optional

The matched authorized IP or network (if found)

error
APIError

optional

result
boolean

Whether the IP is allowed

ControlSmsRequest

command
string

The SMS control command. The following values are possible: enable, disable

phoneNumber
string

The phone number

ControlSmsResponse

error
APIError

optional

result
number

CreateCallListRequest

delimiter
string

optional

Separator values. The default value is ’;’

encoding
string

optional

Encoding file. The default value is UTF-8

escape
string

optional

Escape character for parsing csv

fileContent
Buffer

Send as the “body” part of the HTTP request or as multiform. The sending “file_content” via URL is at its own risk because the network devices tend to drop HTTP requests with large headers

intervalSeconds
number

optional

Interval between call attempts in seconds. The default value is 0

maxSimultaneous
number

Number of simultaneously processed tasks

name
string

File name, up to 255 characters and cannot contain the ’/’ and ” symbols

numAttempts
number

Number of attempts. Minimum is 1, maximum is 5

priority
number

Call list priority. The value is in the range of [0 … 2^31] where zero is the highest priority

referenceIp
string

optional

IP from the geolocation of the call list subscribers. It allows selecting the nearest server for serving subscribers

ruleId
number

Rule ID. It is specified in the Applications(//manage.voximplant.com/applications) section of the Control Panel

serverLocation
string

optional

Location of the server where the scenario needs to be executed. Has higher priority than reference_ip. Request getServerLocations(https://api.voximplant.com/getServerLocations) for possible values

taskPriorityStrategy
string

optional

Optional. Whether to prioritize first calling attempts or repeated ones. The possible values are: first_attempts, repeated_attempts. The default values is first_attempts.

CreateCallListResponse

batchId
string

Batch UUID

count
number

Number of stored records

error
APIError

optional

listId
number

List ID

result
boolean

Whether the request completed successfully

DelAdminRoleRequest

adminRoleId
'any' | number | number[]

The admin role ID list separated by semicolons (;). Use the ‘all’ value to select all admin roles

adminRoleName
string | string[]

The admin role name to delete, can be used instead of admin_role_id

DelAdminRoleResponse

error
APIError

optional

result
number

Returns 1 if the request has been completed successfully

DelAdminUserRequest

requiredAdminUserId
'any' | number | number[]

The admin user ID list separated by semicolons (;). Use the ‘all’ value to select all admin users

requiredAdminUserName
string | string[]

The admin user name to delete, can be used instead of required_admin_user_id

DelAdminUserResponse

error
APIError

optional

result
number

Returns 1 if the request has been completed successfully

DelApplicationRequest

applicationId
'any' | number | number[]

The application ID list separated by semicolons (;). Use the ‘all’ value to select all applications

applicationName
string | string[]

The application name list separated by semicolons (;). Can be used instead of application_id

DelApplicationResponse

error
APIError

optional

result
number

Returns 1 if the request has been completed successfully

DelAuthorizedAccountIPRequest

allowed
boolean

optional

Whether to remove the network from the white list. Set false to remove the network from the black list. Omit the parameter to remove the network from all lists

authorizedIp
string

The authorized IP4 or network to remove. Set to ‘all’ to remove all items

containsIp
string

Specify the parameter to remove the networks that contains the particular IP4. Can be used instead of authorized_ip

DelAuthorizedAccountIPResponse

error
APIError

optional

result
number

The removed network count

DelCallerIDRequest

calleridId
number

ID of the callerID object

calleridNumber
string

The callerID number that can be used instead of callerid_id

DelCallerIDResponse

error
APIError

optional

result
number

Returns 1 if the request has been completed successfully

DeleteCallListRequest

accountId
number

Account’s ID

listId
number

DeleteCallListResponse

error
APIError

optional

msg
string

Text description

result
boolean

Result

DelKeyValueItemRequest

applicationId
number

The application ID

applicationName
string

optional

The application name

key
string

Key, up to 200 characters

DelKeyValueItemResponse

error
APIError

optional

result
number

DelOutboundTestPhoneNumberRequest

DelOutboundTestPhoneNumberResponse

error
APIError

optional

result
number

Returns 1 if the request has been completed successfully

DelPstnBlackListItemRequest

pstnBlacklistId
number

The PSTN black list item ID

DelPstnBlackListItemResponse

error
APIError

optional

result
number

Returns 1 if the request has been completed successfully

DelQueueRequest

acdQueueId
'any' | number | number[]

The ACD queue ID list separated by semicolons (;)

acdQueueName
string | string[]

The ACD queue name that can be used instead of acd_queue_id. The ACD queue name list separated by semicolons (;)

DelQueueResponse

error
APIError

optional

result
number

Returns 1 if the request has been completed successfully

DelSecretRequest

applicationId
number

Application ID

applicationName
string

Application name. Can be used instead of application_id

secretId
'any' | number | number[]

IDs to delete. A list separated by semicolons (;). Use the ‘all’ value to delete all secrets

secretName
string | string[]

Secret names to delete. List separated by semicolons (;)

DelSecretResponse

error
APIError

optional

result
number

Returns 1 if the secret has been deleted successfully

DelSipWhiteListItemRequest

sipWhitelistId
number

The SIP white list item ID to delete

DelSipWhiteListItemResponse

error
APIError

optional

result
number

Returns 1 if the request has been completed successfully

DelSkillRequest

skillId
number

The skill ID

skillName
string

The skill name that can be used instead of skill_id

DelSkillResponse

error
APIError

optional

result
number

Returns 1 if the request has been completed successfully

DelUserRequest

applicationId
number

optional

Delete the specified users bound to the application ID. It is required if the user_name is specified

applicationName
string

optional

Delete the specified users bound to the application name. Can be used instead of the application_id parameter

userId
'any' | number | number[]

The user ID list separated by semicolons (;). Use the ‘all’ value to select all users

userName
string | string[]

The user name list separated by semicolons (;) that can be used instead of user_id

DelUserResponse

error
APIError

optional

result
number

Returns 1 if the request has been completed successfully

DialogflowCredentialsInterface

setDialogflowKey
(request: SetDialogflowKeyRequest) => Promise<SetDialogflowKeyResponse>

Edits a Dialogflow key.

DownloadInvoiceRequest

invoiceId
number

Invoice ID

DownloadInvoiceResponse

error
APIError

optional

fileContent
Buffer

The method returns a raw data, there is no ‘file_content’ parameter in fact

EditCallListRequest

intervalSeconds
number

optional

Minimum interval between call attempts. Cannot be a negative value

ipAddress
string

optional

IP address in the Inet4Address format

listId
number

Call list ID. If the ID is non existing, the 251 error returns

maxSimultaneous
number

optional

Maximum simultaneous call attempts for this call list. Cannot be less than 1

name
string

optional

Call list name. Cannot be bigger than 255 characters, cannot contain slash symbol

numAttempts
number

optional

Maximum call attempt number. Cannot be less than 1

priority
number

optional

Call list’s priority among other call list. The lower the value, the higher is the call list’s priority

serverLocation
string

optional

Location of the server processing the call list. If the ID is non existing, the 496 error returns: The ‘server_location’ parameter is invalid.

startAt
string

optional

Time when the call list should start in the yyyy-MM-dd HH:mm:ss format

taskPriorityStrategy
string

optional

Optional. Whether to prioritize first calling attempts or repeated ones. The possible values are: first_attempts, repeated_attempts. The default values is first_attempts

EditCallListResponse

error
APIError

optional

result
boolean

Whether the request completed successfully

EditCallListTasksPriorityRequest

listId
number

Call list ID. If the ID does not exist, the 251 error returns.

tasks
string

JSON-encoded array of task objects. Each object should contain either ‘task_id’ (number) or ‘task_uuid’ (string), and ‘task_priority’ (number).

EditCallListTasksPriorityResponse

error
APIError

optional

results
string

JSON-encoded array of each task update.

ExchangeRates

EUR
number

optional

The EUR exchange rate

KZT
number

optional

The KZT exchange rate

RUR
number

optional

The RUR exchange rate

USD
number

optional

The USD exchange rate. It is always equal to 1

FailedSms

destinationNumber
string

The SMS destination number

errorCode
number

The error code

errorDescription
string

The error description

GetAccountInfoRequest

returnLiveBalance
boolean

optional

Whether to get the account’s live balance

GetAccountInfoResponse

apiAddress
string

The preferred address for the Management API requests

error
APIError

optional

result
AccountInfo

Account’s info as the AccountInfoType object instance

GetAccountInvoicesRequest

count
number

optional

Number of invoices to show per page. Default value is 20

offset
number

optional

Number of invoices to skip (e.g. if you set count = 20 and offset = 0 the first time, the next time, offset has to be equal to 20 to skip the items shown earlier). Default value is 0

status
string

optional

GetAccountInvoicesResponse

count
number

Number of returned invoices matching the query parameters

error
APIError

optional

result
AccountInvoice

Array of the account invoices

totalCount
number

Total number of invoices matching the query parameters

GetACDStateRequest

acdQueueId
'any' | number | number[]

optional

The ACD queue ID list separated by semicolons (;). Use the ‘all’ value to select all ACD queues

GetACDStateResponse

error
APIError

optional

result
ACDState

GetAdminRolesRequest

adminRoleActive
boolean

optional

Whether the admin role is enabled to filter

adminRoleId
number

optional

The admin role ID to filter

adminRoleName
string

optional

The admin role name part to filter

count
number

optional

The max returning record count

excludedAdminUserId
'any' | number | number[]

optional

Not attached admin user ID list separated by semicolons (;). Use the ‘all’ value to select all admin users

fullAdminUsersMatching
string

optional

Set false to get roles with partial admin user list matching

includedAdminUserId
'any' | number | number[]

optional

The attached admin user ID list separated by semicolons (;). Use the ‘all’ value to select all admin users

offset
number

optional

The first N records are skipped in the output

showingAdminUserId
number

optional

The admin user to show in the ‘admin_users’ field output

withAccountRoles
boolean

optional

Whether to include the account roles

withEntries
boolean

optional

Whether to get the permissions

withParentRoles
boolean

optional

Whether to include the parent roles

withSystemRoles
boolean

optional

GetAdminRolesResponse

count
number

The returned admin role count

error
APIError

optional

result
AdminRole[]
totalCount
number

The total found admin role count

GetAdminUsersRequest

adminUserActive
boolean

optional

Whether the admin user is active to filter

adminUserDisplayName
string

optional

The admin user display name part to filter

count
number

optional

The max returning record count

offset
number

optional

The first N records are skipped in the output

requiredAdminUserId
number

optional

The admin user ID to filter

requiredAdminUserName
string

optional

The admin user name part to filter

withAccessEntries
boolean

optional

Whether to get the admin user permissions

withRoles
boolean

optional

Whether to get the attached admin roles

GetAdminUsersResponse

count
number

The returned admin user count

error
APIError

optional

result
AdminUser[]
totalCount
number

The total found admin user count

GetApplicationsRequest

applicationId
number

optional

The application ID to filter

applicationName
string

optional

The application name part to filter

count
number

optional

The max returning record count

offset
number

optional

The first N records are skipped in the output

withRules
boolean

optional

Whether to get bound rules info

withScenarios
boolean

optional

Whether to get bound rules and scenarios info

GetApplicationsResponse

count
number

The returned application count

error
APIError

optional

result
ApplicationInfo[]
totalCount
number

The total found application count

GetAuthorizedAccountIPsRequest

allowed
boolean

optional

Whether the IP is allowed

authorizedIp
string

optional

The authorized IP4 or network to filter

containsIp
string

optional

Specify the parameter to filter the networks that contains the particular IP4

count
number

optional

The max returning record count

description
string

optional

The IP address description

offset
number

optional

The first N records are skipped in the output

GetAuthorizedAccountIPsResponse

count
number

The returned network count

error
APIError

optional

result
AuthorizedAccountIP[]
totalCount
number

The total found network count

GetAvailableAdminRoleEntriesRequest

GetAvailableAdminRoleEntriesResponse

error
APIError

optional

result
string[]

Array of the admin role entries

GetBriefCallHistoryRequest

applicationId
number

optional

To receive the call history for a specific application, pass the application ID to this parameter

applicationName
string

optional

The application name, can be used instead of application_id

callSessionHistoryCustomData
string

optional

To filter the call history by the custom_data passed to the call sessions, pass the custom data to this parameter

callSessionHistoryId
'any' | number | number[]

optional

To get the call history for the specific sessions, pass the session IDs to this parameter separated by a semicolon (;). You can find the session ID in the AppEvents.Started(/docs/references/voxengine/appevents#started) event’s sessionID property in a scenario, or retrieve it from the call_session_history_id value returned from the StartScenarios(https://voximplant.com/docs/references/httpapi/scenarios#reorderscenarios) or StartConference(https://voximplant.com/docs/references/httpapi/scenarios#startconference) methods

descOrder
boolean

optional

Whether to get records in the descent order

fromDate
Date

The from date in the selected timezone in 24-h format: YYYY-MM-DD HH:mm:ss

localNumber
string | string[]

optional

To receive a call history for a specific local numbers, pass the number list separated by semicolons (;). A local number is a number on the platform side

output
string

The output format. The following values available: csv.

remoteNumber
string | string[]

optional

To receive a call history for a specific remote numbers, pass the number list separated by semicolons (;). A remote number is a number on the client side

ruleName
string

optional

To receive the call history for a specific routing rule, pass the rule name to this parameter. Applies only if you set application_id or application_name

timezone
string

optional

toDate
Date

The to date in the selected timezone in 24-h format: YYYY-MM-DD HH:mm:ss

withHeader
boolean

optional

Whether to get a CSV file with the column names if the output=csv

GetBriefCallHistoryResponse

error
APIError

optional

historyReportId
number

The history report ID

result
number

Returns 1 if the request has been completed successfully

GetCallerIDsRequest

active
boolean

optional

Whether the account is active to filter

calleridId
number

optional

ID of the callerID object to filter

calleridNumber
string

optional

The phone number to filter

count
number

optional

The max returning record count

offset
number

optional

The first N records are skipped in the output

orderBy
string

optional

The following values are available: ‘caller_number’ (ascent order), ‘verified_until’ (ascent order)

GetCallerIDsResponse

count
number

The returned record count

error
APIError

optional

result
CallerIDInfo[]
totalCount
number

The total found record count

GetCallHistoryAsyncRequest

applicationId
number

optional

To receive the call history for a specific application, pass the application ID to this parameter

applicationName
string

optional

The application name, can be used instead of application_id

callSessionHistoryCustomData
string

optional

To filter the call history by the custom_data passed to the call sessions, pass the custom data to this parameter

callSessionHistoryId
'any' | number | number[]

optional

To get the call history for the specific sessions, pass the session IDs to this parameter separated by a semicolon (;). You can find the session ID in the AppEvents.Started(/docs/references/voxengine/appevents#started) event’s sessionID property in a scenario, or retrieve it from the call_session_history_id value returned from the StartScenarios(https://voximplant.com/docs/references/httpapi/scenarios#reorderscenarios) or StartConference(https://voximplant.com/docs/references/httpapi/scenarios#startconference) methods

childAccountId
'any' | number | number[]

optional

The child account ID list separated by semicolons (;)

childrenCallsOnly
boolean

optional

Whether to get the children account calls only

descOrder
boolean

optional

Whether to get records in the descent order

fromDate
Date

The from date in the selected timezone in 24-h format: YYYY-MM-DD HH:mm:ss

localNumber
string | string[]

optional

To receive a call history for a specific local numbers, pass the number list separated by semicolons (;). A local number is a number on the platform side

output
string

optional

The output format. The following values available: csv. The default value is csv

remoteNumber
string | string[]

optional

To receive a call history for a specific remote numbers, pass the number list separated by semicolons (;). A remote number is a number on the client side

ruleName
string

optional

To receive the call history for a specific routing rule, pass the rule name to this parameter. Applies only if you set application_id or application_name

timezone
string

optional

toDate
Date

The to date in the selected timezone in 24-h format: YYYY-MM-DD HH:mm:ss

userId
'any' | number | number[]

optional

To receive the call history for a specific users, pass the user ID list separated by semicolons (;). If it is specified, the output contains the calls from the listed users only

withCalls
boolean

optional

Whether to receive a list of sessions with all calls within the sessions, including phone numbers, call cost and other information

withHeader
boolean

optional

Whether to get a CSV file with the column names if the output=csv

withOtherResources
boolean

optional

Whether to get other resources usage (see ResourceUsageType)

withRecords
boolean

optional

Whether to get the calls’ records

GetCallHistoryAsyncResponse

error
APIError

optional

historyReportId
number

The history report ID

result
number

Returns 1 if the request has been completed successfully

GetCallHistoryRequest

applicationId
number

optional

To receive the call history for a specific application, pass the application ID to this parameter

applicationName
string

optional

The application name, can be used instead of application_id

callSessionHistoryCustomData
string

optional

To filter the call history by the custom_data passed to the call sessions, pass the custom data to this parameter

callSessionHistoryId
'any' | number | number[]

optional

To get the call history for the specific sessions, pass the session IDs to this parameter separated by a semicolon (;). The maximum number of records is 1000. You can find the session ID in the AppEvents.Started(/docs/references/voxengine/appevents#started) event’s sessionID property in a scenario, or retrieve it from the call_session_history_id value returned from the StartScenarios(https://voximplant.com/docs/references/httpapi/scenarios#reorderscenarios) or StartConference(https://voximplant.com/docs/references/httpapi/scenarios#startconference) methods

childAccountId
'any' | number | number[]

optional

The child account ID list separated by semicolons (;)

childrenCallsOnly
boolean

optional

Whether to get the children account calls only

count
number

optional

The number of returning records. The maximum value is 1000

descOrder
boolean

optional

Whether to get records in the descent order

fromDate
Date

The from date in the selected timezone in 24-h format: YYYY-MM-DD HH:mm:ss

localNumber
string | string[]

optional

To receive a call history for a specific local numbers, pass the number list separated by semicolons (;). A local number is a number on the platform side

offset
number

optional

The number of records to skip in the output. The maximum value of 10000

remoteNumber
string | string[]

optional

To receive a call history for a specific remote numbers, pass the number list separated by semicolons (;). A remote number is a number on the client side. Ignored if the remote_number_list parameter is not empty

remoteNumberList
any

optional

A JS array of strings of specific remote phone numbers to sort the call history. Has higher priority than the remote_number parameter. If the array is empty, the remote_number parameter is used instead

ruleName
string

optional

To receive the call history for a specific routing rule, pass the rule name to this parameter. Applies only if you set application_id or application_name

timezone
string

optional

toDate
Date

The to date in the selected timezone in 24-h format: YYYY-MM-DD HH:mm:ss

userId
'any' | number | number[]

optional

To receive the call history for a specific users, pass the user ID list separated by semicolons (;). If it is specified, the output contains the calls from the listed users only

withCalls
boolean

optional

Whether to receive a list of sessions with all calls within the sessions, including phone numbers, call cost and other information

withOtherResources
boolean

optional

Whether to get other resources usage (see ResourceUsageType)

withRecords
boolean

optional

Whether to get the calls’ records

withTotalCount
boolean

optional

Whether to include the ‘total_count’ and increase performance

GetCallHistoryResponse

count
number

The returned call session count

error
APIError

optional

result
CallSessionInfo[]

The CallSessionInfoType records

timezone
string

The used timezone

totalCount
number

The total found call session count

GetCallListsRequest

applicationId
'any' | number | number[]

optional

The application ID to filter. Can be a list separated by semicolons (;). Use the ‘all’ value to select all applications

count
number

optional

The max returning record count

fromDate
Date

optional

The UTC ‘from’ date filter in 24-h format: YYYY-MM-DD HH:mm:ss

isActive
boolean

optional

Whether to find only active call lists

listId
'any' | number | number[]

optional

The list ID to filter. Can be a list separated by semicolons (;). Use the ‘all’ value to select all lists

name
string

optional

Find call lists by name

offset
number

optional

The first N records are skipped in the output

toDate
Date

optional

The UTC ‘to’ date filter in 24-h format: YYYY-MM-DD HH:mm:ss

typeList
string

optional

The type of the call list. The possible values are AUTOMATIC and MANUAL

GetCallListsResponse

count
number

Returned call list count

error
APIError

optional

result
CallList[]

Array of lists

totalCount
number

Total found call list count

GetCurrencyRateRequest

currency
string | string[]

The currency code list separated by semicolons (;). Examples: RUR, KZT, EUR, USD

date
Date

optional

The date, format: YYYY-MM-DD

GetCurrencyRateResponse

error
APIError

optional

result
ExchangeRates

The exchange rates

GetKeyValueItemRequest

applicationId
number

The application ID

applicationName
string

optional

The application name

key
string

Key, up to 200 characters

GetKeyValueItemResponse

error
APIError

optional

result
KeyValueItems

The key-value item

GetKeyValueItemsRequest

applicationId
number

The application ID

applicationName
string

optional

The application name

count
number

optional

Number of items to show per page with a maximum value of 50. Default value is 10

key
string

Namespace that keys should contain, up to 200 characters

offset
number

optional

Number of items to skip (e.g. if you set count = 20 and offset = 0 the first time, the next time, offset has to be equal to 20 to skip the items shown earlier). Default value is 0

GetKeyValueItemsResponse

error
APIError

optional

result
KeyValueItems

The key-value pairs

GetKeyValueKeysRequest

applicationId
number

The application ID

applicationName
string

optional

The application name

count
number

optional

Number of items to show per page with a maximum value of 50. Default value is 10

key
string

optional

Namespace that keys should contain, up to 200 characters

offset
number

optional

Number of items to skip (e.g. if you set count = 20 and offset = 0 the first time, the next time, offset has to be equal to 20 to skip the items shown earlier). Default value is 0

GetKeyValueKeysResponse

error
APIError

optional

result
KeyValueKeys

The key-value keys

GetOutboundTestPhoneNumbersRequest

GetOutboundTestPhoneNumbersResponse

error
APIError

optional

result
OutboundTestPhonenumberInfo[]

GetPhoneNumbersAsyncRequest

withHeader
boolean

optional

Whether to get a CSV file with the column names

GetPhoneNumbersAsyncResponse

error
APIError

optional

result
number

The report ID (async mode)

GetPhoneNumbersRequest

activationStatus
string | string[]

optional

Phone number activation statuses to filter, separated by semicolons (;).

The possible values are: ACTIVE, ACTIVATING, DEACTIVATED, PROVISIONING, AWAITING_BUSINESS_PHONE_NUMBER_CONFIGURATION, LEGAL_OWNERSHIP_LIMIT_REACHED, GOSUSLUGI_DECLINED, SELF_BAN_ENABLED

applicationId
number

optional

Application ID

applicationName
string

optional

Application name that can be used instead of application_id

autoCharge
boolean

optional

Whether the auto_charge flag is enabled

canBeUsed
boolean

optional

Whether a not verified account can use the phone

canceled
boolean

optional

Whether the subscription is cancelled to filter

childAccountId
'any' | number | number[]

optional

Child account ID list separated by semicolons (;). Use the ‘all’ value to select all child accounts

childrenPhonesOnly
boolean

optional

Whether to get the children phones only

count
number

optional

Maximum returning record count

countryCode
string | string[]

optional

Country code list separated by semicolons (;)

deactivated
boolean

optional

Whether the subscription is frozen to filter

fromPhoneNextRenewal
Date

optional

UTC ‘from’ date filter in the following format: YYYY-MM-DD

fromPhonePurchaseDate
Date

optional

UTC ‘from’ date filter in 24-h format: YYYY-MM-DD HH:mm:ss

fromUnverifiedHoldUntil
Date

optional

Unverified phone hold until the date (from …) in the following format: YYYY-MM-DD

isBoundToApplication
boolean

optional

Whether the phone number bound to an application

isBoundToRule
boolean

optional

Whether the phone number is bound to some rule

offset
number

optional

First N records are skipped in the output

orderBy
string

optional

Following values are available: ‘phone_number’ (ascent order), ‘phone_price’ (ascent order), ‘phone_country_code’ (ascent order), ‘deactivated’ (deactivated first, active last), ‘purchase_date’ (descent order), ‘phone_next_renewal’ (ascent order), ‘verification_status’, ‘unverified_hold_until’ (ascent order), ‘verification_name’

phoneCategoryName
string

optional

Phone category name. See the GetPhoneNumberCategories method

phoneId
'any' | number | number[]

optional

Particular phone ID to filter

phoneNumber
string | string[]

optional

Phone number list separated by semicolons (;) that can be used instead of phone_id

phoneRegionName
string | string[]

optional

Region names list separated by semicolons (;)

phoneTemplate
string

optional

Phone number start to filter

ruleId
'any' | number | number[]

optional

Rule ID list separated by semicolons (;)

ruleName
string | string[]

optional

Rule names list separated by semicolons (;). Can be used only if application_id or application_name is specified

sandbox
string

optional

Flag allows you to display only the numbers of the sandbox, real numbers, or all numbers. The following values are possible: ‘all’, ‘true’, ‘false’

smsSupported
boolean

optional

toPhoneNextRenewal
Date

optional

UTC ‘to’ date filter in the following format: YYYY-MM-DD

toPhonePurchaseDate
Date

optional

UTC ‘to’ date filter in 24-h format: YYYY-MM-DD HH:mm:ss

toUnverifiedHoldUntil
Date

optional

Unverified phone hold until the date (… to) in the following format: YYYY-MM-DD

verificationName
string

optional

Required account verification name to filter

verificationStatus
string | string[]

optional

Account verification status list separated by semicolons (;). The following values are possible: REQUIRED, IN_PROGRESS, VERIFIED

GetPhoneNumbersResponse

count
number

Returned phone count

error
APIError

optional

result
AttachedPhoneInfo[]

Phone numbers info

totalCount
number

Total found phone count

GetPstnBlackListRequest

count
number

optional

The max returning record count

offset
number

optional

The first N records are skipped in the output

pstnBlacklistId
number

optional

The PSTN black list item ID for filter

pstnBlacklistPhone
string

optional

The phone number in format e164 for filter

GetPstnBlackListResponse

count
number

The returned phone numbers count

error
APIError

optional

result
PstnBlackListInfo[]
totalCount
number

The total found phone numbers count

GetQueuesRequest

acdQueueId
number

optional

The ACD queue ID to filter

acdQueueName
string

optional

The ACD queue name part to filter

applicationId
number

optional

The application ID to filter

count
number

optional

The max returning record count

excludedSkillId
number

optional

The excluded skill ID to filter

offset
number

optional

The first N records are skipped in the output

showingSkillId
number

optional

The skill to show in the ‘skills’ field output

skillId
number

optional

The skill ID to filter

withOperatorcount
boolean

optional

Whether to include the number of agents bound to the queue

withSkills
boolean

optional

Whether to get the bound skills

GetQueuesResponse

count
number

The returned queue count

error
APIError

optional

result
QueueInfo[]
totalCount
number

The total found queue count

GetRecordStoragesRequest

recordStorageId
'any' | number | number[]

optional

The record storage ID list separated by semicolons (;)

recordStorageName
string | string[]

optional

The record storage name list separated by semicolons (;)

withPrivate
boolean

optional

GetRecordStoragesResponse

error
APIError

optional

result
RecordStorageInfo

GetRoleGroupsRequest

GetRoleGroupsResponse

error
APIError

optional

result
RoleGroupView[]

GetSecretsRequest

applicationId
number

Application ID

applicationName
string

Application name. Can be used instead of application_id

count
number

optional

Maximum returning record number

offset
number

optional

First N records to be skipped in the output

secretNamePart
string

optional

Filter by the secret name part

GetSecretsResponse

count
number

Returned secrets number

error
APIError

optional

result
SecretListItem[]

Secrets list

totalCount
number

Total found secrets number

GetSecretValueRequest

applicationId
number

Application ID

applicationName
string

Application name. Can be used instead of application_id

secretId
number

Secret ID

secretName
string

Secret name. Can be used instead of secret_id

GetSecretValueResponse

error
APIError

optional

result
GetSecretValueResult[]

The full secret info (with value)

GetSecretValueResult

created
Date

Secret creation timestamp

description
string

optional

Secret description

modified
Date

Secret modification timestamp

secretId
number

Secret ID

secretName
string

Secret name

secretValue
string

Secret value

GetSipRegistrationsRequest

applicationId
'any' | number | number[]

optional

The application ID list separated by semicolons (;) to filter. Can be used instead of application_name

applicationName
string | string[]

optional

The application name list separated by semicolons (;) to filter. Can be used instead of application_id

count
number

optional

The max returning record count

deactivated
boolean

optional

Whether to show the frozen SIP registrations only

inProgress
boolean

optional

Whether SIP registration is still in progress

isBoundToApplication
boolean

optional

Whether SIP registration bound to an application

isPersistent
boolean

optional

Whether the SIP registration is persistent to filter

offset
number

optional

The first N records are skipped in the output

proxy
string | string[]

optional

The list of proxy servers to use, divided by semicolon (;)

ruleId
'any' | number | number[]

The rule ID list separated by semicolons (;) to filter. Can be used instead of rule_name

ruleName
string | string[]

The rule name list separated by semicolons (;) to filter. Can be used instead of rule_id

sipRegistrationId
number

optional

The SIP registration ID

sipUsername
string

optional

The SIP user name to filter

statusCode
string

optional

The list of SIP response codes. The code1:code2 means a range from code1 to code2 including; the code1;code2 meanse either code1 or code2. You can combine ranges, e.g., code1;code2:code3

successful
boolean

optional

Whether to show the successful SIP registrations only

userId
'any' | number | number[]

The user ID list separated by semicolons (;) to filter. Can be used instead of user_name

userName
string | string[]

GetSipRegistrationsResponse

count
number

Count rows

error
APIError

optional

result
SIPRegistration[]

Active SIP registrations

GetSipWhiteListRequest

count
number

optional

The max returning record count

offset
number

optional

The first N records are skipped in the output

sipWhitelistId
number

optional

The SIP white list item ID to filter

GetSipWhiteListResponse

count
number

The returned networks count

error
APIError

optional

result
SipWhiteListInfo[]
totalCount
number

The total found networks count

GetSkillsRequest

count
number

optional

The max returning record count

offset
number

optional

The first N records are skipped in the output

skillId
number

optional

The skill ID to filter

skillName
string

optional

The skill name part to filter

GetSkillsResponse

count
number

The returned skill count

error
APIError

optional

result
SkillInfo[]
totalCount
number

The total found skill count

GetSmartQueueDayHistoryRequest

applicationId
number

The application ID to search by

applicationName
string

The application name to search by. Can be used instead of the application_id parameter

fromDate
Date

optional

The from date in the selected timezone in 24-h format: YYYY-MM-DD HH:mm:ss. Default is the current time minus 1 day

groupBy
string

optional

Group the result by agent or queue. The agent grouping is allowed only for 1 queue and for the occupancy_rate, sum_agents_online_time, sum_agents_ready_time, sum_agents_dialing_time, sum_agents_in_service_time, sum_agents_afterservice_time, sum_agents_dnd_time, sum_agents_banned_time, min_handle_time, max_handle_time, average_handle_time, count_handled_calls, min_after_call_worktime, max_after_call_worktime, average_after_call_worktime report types. The queue grouping allowed for the calls_blocked_percentage, count_blocked_calls, average_abandonment_rate, count_abandonment_calls, service_level, occupancy_rate, min_time_in_queue, max_time_in_queue, average_time_in_queue, min_answer_speed, max_answer_speed, average_answer_speed, min_handle_time, max_handle_time, average_handle_time, count_handled_calls, min_after_call_worktime, max_after_call_worktime, average_after_call_worktime report types

interval
string

optional

Interval format: YYYY-MM-DD HH:mm:ss. Default is 1 day

maxWaitingSec
number

optional

Maximum waiting time. Required for the service_level report type

reportType
string | string[]

The report type. Possible values are: calls_blocked_percentage, count_blocked_calls, im_blocked_chats_percentage, im_count_blocked_chats, im_answered_chats_rate, average_abandonment_rate, count_abandonment_calls, service_level, im_service_level, occupancy_rate, im_agent_occupancy_rate, agent_utilization_rate, im_agent_utilization_rate, sum_agents_online_time, sum_agents_ready_time, sum_agents_dialing_time, sum_agents_in_service_time, sum_agents_in_service_incoming_time, sum_agents_in_service_outcoming_time, sum_agents_afterservice_time, sum_agents_dnd_time, sum_agents_custom_1_time, sum_agents_custom_2_time, sum_agents_custom_3_time, sum_agents_custom_4_time, sum_agents_custom_5_time, sum_agents_custom_6_time, sum_agents_custom_7_time, sum_agents_custom_8_time, sum_agents_custom_9_time, sum_agents_custom_10_time, sum_agents_banned_time, im_sum_agents_online_time, im_sum_agents_ready_time, im_sum_agents_in_service_time, im_sum_agents_dnd_time, im_sum_agents_custom_1_time, im_sum_agents_custom_2_time, im_sum_agents_custom_3_time, im_sum_agents_custom_4_time, im_sum_agents_custom_5_time, im_sum_agents_custom_6_time, im_sum_agents_custom_7_time, im_sum_agents_custom_8_time, im_sum_agents_custom_9_time, im_sum_agents_custom_10_time, im_sum_agents_banned_time, average_agents_idle_time, max_agents_idle_time, min_agents_idle_time, percentile_0_25_agents_idle_time, percentile_0_50_agents_idle_time, percentile_0_75_agents_idle_time, min_time_in_queue, max_time_in_queue, average_time_in_queue, min_answer_speed, max_answer_speed, average_answer_speed, im_min_answer_speed, im_max_answer_speed, im_average_answer_speed, min_handle_time, max_handle_time, average_handle_time, count_handled_calls, min_after_call_worktime, max_after_call_worktime, average_after_call_worktime, count_agent_unanswered_calls, im_count_agent_unanswered_chats, min_reaction_time, max_reaction_time, average_reaction_time, im_min_reaction_time, im_max_reaction_time, im_average_reaction_time, im_count_abandonment_chats, im_count_lost_chats, im_lost_chats_rate, call_count_assigned_to_queue, im_count_assigned_to_queue

sqQueueId
'any' | number | number[]

The SmartQueue ID list with a maximum of 5 values separated by semicolons (;). Can operate as filter for the calls_blocked_percentage, count_blocked_calls, average_abandonment_rate, count_abandonment_calls, service_level, occupancy_rate, min_time_in_queue, max_time_in_queue, average_time_in_queue, min_answer_speed, max_answer_speed, average_answer_speed, min_handle_time, max_handle_time, average_handle_time, count_handled_calls, min_after_call_worktime, max_after_call_worktime, average_after_call_worktime report types

sqQueueName
string | string[]

optional

The SmartQueue name list separated by semicolons (;). Can be used instead of sq_queue_id

timezone
string

optional

The selected timezone or the ‘auto’ value (the account location)

toDate
Date

optional

The to date in the selected timezone in 24-h format: YYYY-MM-DD HH:mm:ss. Default is the current time

userId
'any' | number | number[]

optional

The user ID list with a maximum of 5 values separated by semicolons (;). Use the ‘all’ value to select all users. Can operate as a filter for the occupancy_rate, sum_agents_online_time, sum_agents_ready_time, sum_agents_dialing_time, sum_agents_in_service_time, sum_agents_afterservice_time, sum_agents_dnd_time, sum_agents_banned_time, min_handle_time, max_handle_time, average_handle_time, count_handled_calls, min_after_call_worktime, max_after_call_worktime, average_after_call_worktime report types

userName
string | string[]

optional

The user name list separated by semicolons (;). user_name can be used instead of user_id

GetSmartQueueDayHistoryResponse

error
APIError

optional

result
SmartQueueMetricsResult[]
timezone
string

The used timezone, e.g., ‘Etc/GMT’

GetSmartQueueRealtimeMetricsRequest

applicationId
number

The application ID to search by

applicationName
string

The application name to search by. Can be used instead of the application_id parameter

fromDate
Date

optional

The from date in the selected timezone in 24-h format: YYYY-MM-DD HH:mm:ss. Default is the current time minus 30 minutes

groupBy
string

optional

Group the result by agent or queue. The agent grouping is allowed for 1 queue and for the occupancy_rate, sum_agents_online_time, sum_agents_ready_time, sum_agents_dialing_time, sum_agents_in_service_time, sum_agents_afterservice_time, sum_agents_dnd_time, sum_agents_banned_time, min_handle_time, max_handle_time, average_handle_time, count_handled_calls, min_after_call_worktime, max_after_call_worktime, average_after_call_worktime report types. The queue grouping allowed for the calls_blocked_percentage, count_blocked_calls, average_abandonment_rate, count_abandonment_calls, service_level, occupancy_rate, min_time_in_queue, max_time_in_queue, average_time_in_queue, min_answer_speed, max_answer_speed, average_answer_speed, min_handle_time, max_handle_time, average_handle_time, count_handled_calls, min_after_call_worktime, max_after_call_worktime, average_after_call_worktime report types

interval
string

optional

Interval format: YYYY-MM-DD HH:mm:ss. Default is 30 minutes

maxWaitingSec
number

optional

Maximum waiting time. Required for the service_level report type

reportType
string | string[]

The report type. Possible values are: calls_blocked_percentage, count_blocked_calls, im_blocked_chats_percentage, im_count_blocked_chats, im_answered_chats_rate, average_abandonment_rate, count_abandonment_calls, service_level, im_service_level, occupancy_rate, im_agent_occupancy_rate, agent_utilization_rate, im_agent_utilization_rate, sum_agents_online_time, sum_agents_ready_time, sum_agents_dialing_time, sum_agents_in_service_time, sum_agents_in_service_incoming_time, sum_agents_in_service_outcoming_time, sum_agents_afterservice_time, sum_agents_dnd_time, sum_agents_custom_1_time, sum_agents_custom_2_time, sum_agents_custom_3_time, sum_agents_custom_4_time, sum_agents_custom_5_time, sum_agents_custom_6_time, sum_agents_custom_7_time, sum_agents_custom_8_time, sum_agents_custom_9_time, sum_agents_custom_10_time, sum_agents_banned_time, im_sum_agents_online_time, im_sum_agents_ready_time, im_sum_agents_in_service_time, im_sum_agents_dnd_time, im_sum_agents_custom_1_time, im_sum_agents_custom_2_time, im_sum_agents_custom_3_time, im_sum_agents_custom_4_time, im_sum_agents_custom_5_time, im_sum_agents_custom_6_time, im_sum_agents_custom_7_time, im_sum_agents_custom_8_time, im_sum_agents_custom_9_time, im_sum_agents_custom_10_time, im_sum_agents_banned_time, average_agents_idle_time, max_agents_idle_time, min_agents_idle_time, percentile_0_25_agents_idle_time, percentile_0_50_agents_idle_time, percentile_0_75_agents_idle_time, min_time_in_queue, max_time_in_queue, average_time_in_queue, min_answer_speed, max_answer_speed, average_answer_speed, im_min_answer_speed, im_max_answer_speed, im_average_answer_speed, min_handle_time, max_handle_time, average_handle_time, count_handled_calls, min_after_call_worktime, max_after_call_worktime, average_after_call_worktime, count_agent_unanswered_calls, im_count_agent_unanswered_chats, min_reaction_time, max_reaction_time, average_reaction_time, im_min_reaction_time, im_max_reaction_time, im_average_reaction_time, im_count_abandonment_chats, im_count_lost_chats, im_lost_chats_rate, call_count_assigned_to_queue, im_count_assigned_to_queue

sqQueueName
string | string[]

optional

The SmartQueue name list separated by semicolons (;). Can be used instead of sq_queue_id

timezone
string

optional

The selected timezone or the ‘auto’ value (the account location)

toDate
Date

optional

The to date in the selected timezone in 24-h format: YYYY-MM-DD HH:mm:ss. Default is the current time

userId
'any' | number | number[]

optional

The user ID list with a maximum of 5 values separated by semicolons (;). Use the ‘all’ value to select all users. Can operate as a filter for the occupancy_rate, sum_agents_online_time, sum_agents_ready_time, sum_agents_dialing_time, sum_agents_in_service_time, sum_agents_afterservice_time, sum_agents_dnd_time, sum_agents_banned_time, min_handle_time, max_handle_time, average_handle_time, count_handled_calls, min_after_call_worktime, max_after_call_worktime, average_after_call_worktime report types

userName
string | string[]

optional

The user name list separated by semicolons (;). user_name can be used instead of user_id

GetSmartQueueRealtimeMetricsResponse

error
APIError

optional

result
SmartQueueMetricsResult[]
timezone
string

The used timezone, e.g., ‘Etc/GMT’

GetSmsHistoryRequest

count
number

optional

Maximum number of resulting rows fetched. Must be not bigger than 1000. If left blank, then the default value of 1000 is used

destinationNumber
string

optional

The destination phone number

direction
string

optional

Sent or received SMS. Possible values: ‘IN’, ‘OUT’, ‘in, ‘out’. Leave blank to get both incoming and outgoing messages

fromDate
Date

optional

Date from which to perform search. Format is ‘yyyy-MM-dd HH:mm:ss’, time zone is UTC

offset
number

optional

The first N records are skipped in the output

output
string

optional

The output format. The following values available: json, csv, xls. The default value is json

sourceNumber
string

optional

The source phone number

timezone
string

optional

toDate
Date

optional

Date until which to perform search. Format is ‘yyyy-MM-dd HH:mm:ss’, time zone is UTC

GetSmsHistoryResponse

error
APIError

optional

result
SmsHistory[]
totalCount
number

Total number of messages matching the query parameters

GetSQAgentsResult

maxSimultaneousConversations
number

optional

Maximum number of chats that the user processes simultaneously

sqQueues
any

optional

JSON array of the agent’s queues

sqSkills
any

optional

JSON array of the agent’s skills

sqStatuses
SmartQueueStateAgentStatus[]

optional

Agent statuses info

userDisplayName
string

optional

Display name of the user

userId
number

optional

ID of the user

userName
string

optional

Name of the user

GetSQQueuesResult

agentcount
number

optional

Number of agents bound to the queue

agentSelection
string

Agent selection strategy

callMaxQueueSize
number

optional

Maximum size of the queue with CALL-type requests

callMaxWaitingTime
number

optional

Maximum time in minutes that a CALL-type request can remain in the queue without being assigned to an agent in minutes. If the value has been passed in seconds, this field is also present in the answer, rounded to the bigger number

callMaxWaitingTimeInSeconds
number

optional

Maximum time in minutes that a CALL-type request can remain in the queue without being assigned to an agent in seconds. If the value has been passed in minutes, this field is also present in the answer

created
Date

optional

UTC date of the queue creation in 24-h format: YYYY-MM-DD HH:mm:ss

description
string

optional

Comment

holdCallsIfInactiveAgents
boolean

optional

Whether the call task is kept in the queue if all agents are unavailable

holdImIfInactiveAgents
boolean

optional

Whether the tasks are queued when there are no active agents

imMaxQueueSize
number

optional

Maximum size of the queue with IM-type requests

imMaxWaitingTime
number

optional

Maximum time in minutes that an IM-type request can remain in the queue without being assigned to an agent in minutes. If the value has been passed in seconds, this field is also present in the answer, rounded to the bigger number

imMaxWaitingTimeInSeconds
number

optional

Maximum time in minutes that an IM-type request can remain in the queue without being assigned to an agent in seconds. If the value has been passed in minutes, this field is also present in the answer

modified
Date

optional

UTC date of the queue modification in 24-h format: YYYY-MM-DD HH:mm:ss

sqQueueId
number

ID of the SmartQueue

sqQueueName
string

Name of the SmartQueue

taskSelection
string

Strategy of prioritizing requests for service

GetSQSkillsResult

created
Date

optional

UTC date of the queue creation in 24-h format: YYYY-MM-DD HH:mm:ss

description
string

optional

Comment

modified
Date

optional

UTC date of the queue modification in 24-h format: YYYY-MM-DD HH:mm:ss

sqSkillId
number

ID of the skill

sqSkillName
string

Name of the skill

GetSQStateRequest

applicationId
number

The application ID to search by

applicationName
string

optional

The application name to search by. Can be used instead of the application_id parameter

sqQueueId
'any' | number | number[]

The SmartQueue ID list separated by semicolons (;). Use the ‘all’ value to select all SmartQueues

sqQueueName
string | string[]

optional

The SmartQueue name list separated by semicolons (;). Can be used instead of sq_queue_id

timezone
string

optional

The selected timezone or the ‘auto’ value (the account location)

GetSQStateResponse

error
APIError

optional

result
SmartQueueState[]

GetTransactionHistoryAsyncRequest

childAccountId
'any' | number | number[]

optional

The child account ID list separated by semicolons (;). Use the ‘all’ value to select all child accounts

childrenTransactionsOnly
boolean

optional

Whether to get the children account transactions only

descOrder
boolean

optional

Whether to get records in the descent order

fromDate
Date

The from date in the selected timezone in 24-h format: YYYY-MM-DD HH:mm:ss

isUncommitted
boolean

optional

Whether to get transactions on hold (transactions for which money is reserved but not yet withdrawn from the account)

output
string

optional

The output format. The following values available: csv. The default value is csv

paymentReference
string

optional

timezone
string

optional

toDate
Date

The to date in the selected timezone in 24-h format: YYYY-MM-DD HH:mm:ss

transactionId
'any' | number | number[]

optional

The transaction ID list separated by semicolons (;)

transactionType
string | string[]

optional

The transaction type list separated by semicolons (;). The following values are possible: gift_revoke, resource_charge, money_distribution, subscription_charge, subscription_installation_charge, card_periodic_payment, card_overrun_payment, card_payment, rub_card_periodic_payment, rub_card_overrun_payment, rub_card_payment, robokassa_payment, gift, promo, adjustment, wire_transfer, us_wire_transfer, refund, discount, mgp_charge, mgp_startup, mgp_business, mgp_big_business, mgp_enterprise, mgp_large_enterprise, techsupport_charge, tax_charge, monthly_fee_charge, grace_credit_payment, grace_credit_provision, mau_charge, mau_overrun, im_charge, im_overrun, fmc_charge, sip_registration_charge, development_fee, money_transfer_to_child, money_transfer_to_parent, money_acceptance_from_child, money_acceptance_from_parent, phone_number_installation, phone_number_charge, toll_free_phone_number_installation, toll_free_phone_number_charge, services, user_money_transfer, paypal_payment, paypal_overrun_payment, paypal_periodic_payment

userId
'any' | number | number[]

optional

The user ID list separated by semicolons (;)

usersTransactionsOnly
boolean

optional

Whether to get the users’ transactions only

withHeader
boolean

optional

Whether to get a CSV file with the column names if the output=csv

GetTransactionHistoryAsyncResponse

error
APIError

optional

historyReportId
number

The history report ID

result
number

Returns 1 if the request has been completed successfully

GetTransactionHistoryRequest

childAccountId
'any' | number | number[]

optional

The child account ID list separated by semicolons (;). Use the ‘all’ value to select all child accounts

childrenTransactionsOnly
boolean

optional

Whether to get the children account transactions only

count
number

optional

The number of returning records. The maximum value is 1000

descOrder
boolean

optional

Whether to get records in the descent order

fromDate
Date

The from date in the selected timezone in 24-h format: YYYY-MM-DD HH:mm:ss

isUncommitted
boolean

optional

Whether to get transactions on hold (transactions for which money is reserved but not yet withdrawn from the account)

offset
number

optional

The number of records to skip in the output with a maximum value of 10000

paymentReference
string

optional

timezone
string

optional

toDate
Date

The to date in the selected timezone in 24-h format: YYYY-MM-DD HH:mm:ss

transactionId
'any' | number | number[]

optional

The transaction ID list separated by semicolons (;)

transactionType
string | string[]

optional

The transaction type list separated by semicolons (;). The following values are possible: gift_revoke, resource_charge, money_distribution, subscription_charge, subscription_installation_charge, card_periodic_payment, card_overrun_payment, card_payment, rub_card_periodic_payment, rub_card_overrun_payment, rub_card_payment, robokassa_payment, gift, promo, adjustment, wire_transfer, us_wire_transfer, refund, discount, mgp_charge, mgp_startup, mgp_business, mgp_big_business, mgp_enterprise, mgp_large_enterprise, techsupport_charge, tax_charge, monthly_fee_charge, grace_credit_payment, grace_credit_provision, mau_charge, mau_overrun, im_charge, im_overrun, fmc_charge, sip_registration_charge, development_fee, money_transfer_to_child, money_transfer_to_parent, money_acceptance_from_child, money_acceptance_from_parent, phone_number_installation, phone_number_charge, toll_free_phone_number_installation, toll_free_phone_number_charge, services, user_money_transfer, paypal_payment, paypal_overrun_payment, paypal_periodic_payment

userId
'any' | number | number[]

optional

The user ID list separated by semicolons (;)

usersTransactionsOnly
boolean

optional

Whether to get the users’ transactions only

withTotalCount
boolean

optional

Whether to include the ‘total_count’ and increase performance

GetTransactionHistoryResponse

count
number

The returned transaction count

error
APIError

optional

result
TransactionInfo[]
timezone
string

The used timezone. ‘Etc/GMT’ for example

totalCount
number

The total found transaction count

GetUsersRequest

acdQueueId
number

optional

The ACD queue ID to filter

acdStatus
string | string[]

optional

The ACD status list separated by semicolons (;) to filter. The following values are possible: OFFLINE, ONLINE, READY, BANNED, IN_SERVICE, AFTER_SERVICE, TIMEOUT, DND

applicationId
number

The application ID to filter

applicationName
string

The application name part to filter

count
number

optional

The max returning record count

excludedAcdQueueId
number

optional

The excluded ACD queue ID to filter

excludedSkillId
number

optional

The excluded skill ID to filter

offset
number

optional

The first N records are skipped in the output

orderBy
string

optional

The following values are available: ‘user_id’, ‘user_name’ and ‘user_display_name’

returnLiveBalance
boolean

optional

Whether to get the user live balance

showingSkillId
number

optional

The skill to show in the ‘skills’ field output

skillId
number

optional

The skill ID to filter

userActive
boolean

optional

Whether the user is active to filter. Inactive users cannot log in to applications

userDisplayName
string

optional

The user display name part to filter

userId
number

optional

The user ID to filter

userName
string

optional

The user name part to filter

withQueues
boolean

optional

Whether to get the bound queues

withSkills
boolean

optional

Whether to get the bound skills

GetUsersResponse

count
number

The returned user count

error
APIError

optional

result
UserInfo[]

The UserInfoType records

totalCount
number

The total found user count

GetWABPhoneNumbersRequest

applicationId
number

optional

Application ID that is bound to the WhatsApp Business phone number

applicationName
string

optional

Bound application name that can be used instead of application_id

count
number

optional

Maximum returning records count

countryCode
string

optional

Country code filter (2 symbols) for the WhatsApp Business phone number

offset
number

optional

Number of records to be skipped in the result

wabPhoneNumber
string

optional

WhatsApp Business phone number

GetWABPhoneNumbersResponse

count
number

Number of returned records

error
APIError

optional

result
WABPhoneInfo[]

WhatsApp Business phone numbers info

totalCount
number

Number of total records found

HistoryInterface

getBriefCallHistory
(\n request: GetBriefCallHistoryRequest\n ) => Promise<GetBriefCallHistoryResponse>

Gets the account’s brief call history in the asynchronous mode. Take a look at the GetHistoryReports and DownloadHistoryReport functions for downloading details.

getCallHistory
(request: GetCallHistoryRequest) => Promise<GetCallHistoryResponse>

Gets the account’s call history (including call duration, cost, logs and other call information). You can filter the call history by a certain date.

getCallHistoryAsync
(\n request: GetCallHistoryAsyncRequest\n ) => Promise<GetCallHistoryAsyncResponse>

The GetCallHistory asynchronous implementation. Use this function to download a large amounts of data. Take a look at the GetHistoryReports and DownloadHistoryReport functions for downloading details.

getTransactionHistory
(\n request: GetTransactionHistoryRequest\n ) => Promise<GetTransactionHistoryResponse>

Gets the transaction history.

getTransactionHistoryAsync
(\n request: GetTransactionHistoryAsyncRequest\n ) => Promise<GetTransactionHistoryAsyncResponse>

The GetTransactionHistory asynchronous implementation. Use this function to download a large amounts of data. Take a look at the GetHistoryReports and DownloadHistoryReport functions for downloading details.

InvoicePeriod

from
Date

From date in the following format: YYYY-MM-DD

to
Date

To date in the following format: YYYY-MM-DD

InvoicesInterface

downloadInvoice
(request: DownloadInvoiceRequest) => Promise<DownloadInvoiceResponse>

Downloads the specified invoice.

getAccountInvoices
(request: GetAccountInvoicesRequest) => Promise<GetAccountInvoicesResponse>

Gets all invoices for the specified USD or EUR account.

InvoiceSpendingDetails

amount
InvoiceTotalDetails

Paid amount

serviceName
string

Service name

taxes
InvoiceTaxesDetails

Array of taxes

InvoiceTaxesDetails

amount
number

Paid amount

category
string

Tax category

currency
string

Tax currency

level
string

Tax type. Possible values: Federal, State, County, City, Unincorporated

name
string

Tax name

rate
number

Tax rate

taxableMeasure
number

Taxable sum

InvoiceTotalDetails

amountToPay
number

Discounted amount to pay

currency
string

Invoice currency

discountAmount
number

Discount

taxAmount
number

Total amount of taxes

totalAmount
number

Invoice total amount including taxes

IsAccountPhoneNumberRequest

phoneNumber
string

Phone number to check in the international format without +

IsAccountPhoneNumberResponse

error
APIError

optional

result
boolean

Whether the number belongs to the account

KeyValueItems

expiresAt
number

Expiration date based on ttl (timestamp without milliseconds)

key
string

Key that matches the specified key or key pattern

value
string

Value for the specified key

KeyValueKeys

expiresAt
number

Expiration date based on ttl (timestamp without milliseconds)

key
string

Key that matches the pattern

KeyValueStorageInterface

delKeyValueItem
(request: DelKeyValueItemRequest) => Promise<DelKeyValueItemResponse>

Deletes the specified key-value pair from the storage.

getKeyValueItem
(request: GetKeyValueItemRequest) => Promise<GetKeyValueItemResponse>

Gets the specified key-value pair from the storage.

getKeyValueItems
(request: GetKeyValueItemsRequest) => Promise<GetKeyValueItemsResponse>

Gets all the key-value pairs in which the keys begin with a pattern.

getKeyValueKeys
(request: GetKeyValueKeysRequest) => Promise<GetKeyValueKeysResponse>

Gets all the keys of key-value pairs.

setKeyValueItem
(request: SetKeyValueItemRequest) => Promise<SetKeyValueItemResponse>

Creates or updates a key-value pair. If an existing key is passed, the method returns the existing item and changes the value if needed. The keys should be unique within a Voximplant application.

OutboundTestNumbersInterface

activateOutboundTestPhoneNumber
(\n request: ActivateOutboundTestPhoneNumberRequest\n ) => Promise<ActivateOutboundTestPhoneNumberResponse>

Activates the phone number by the verification code.

addOutboundTestPhoneNumber
(\n request: AddOutboundTestPhoneNumberRequest\n ) => Promise<AddOutboundTestPhoneNumberResponse>

Adds a personal phone number to test outgoing calls. Only one personal phone number can be used. To replace it with another, delete the existing one first.

delOutboundTestPhoneNumber
(\n request: DelOutboundTestPhoneNumberRequest\n ) => Promise<DelOutboundTestPhoneNumberResponse>

Deletes the existing phone number.

getOutboundTestPhoneNumbers
(\n request: GetOutboundTestPhoneNumbersRequest\n ) => Promise<GetOutboundTestPhoneNumbersResponse>

Shows the phone number info.

verifyOutboundTestPhoneNumber
(\n request: VerifyOutboundTestPhoneNumberRequest\n ) => Promise<VerifyOutboundTestPhoneNumberResponse>

Starts a call to the added phone number and pronounces a verification code. You have only 5 verification attempts per day and 100 in total. 1 minute should pass between 2 attempts.

OutboundTestPhonenumberInfo

countryCode
string

The country code

isVerified
boolean

Whether the phone number is verified

phoneNumber
string

The personal phone number

PhoneNumbersInterface

getPhoneNumbers
(request: GetPhoneNumbersRequest) => Promise<GetPhoneNumbersResponse>

Gets the account phone numbers.

getPhoneNumbersAsync
(\n request: GetPhoneNumbersAsyncRequest\n ) => Promise<GetPhoneNumbersAsyncResponse>

Gets the asynchronous report regarding purchased phone numbers.

isAccountPhoneNumber
(\n request: IsAccountPhoneNumberRequest\n ) => Promise<IsAccountPhoneNumberResponse>

Checks if the phone number belongs to the authorized account.

PstnBlackListInfo

pstnBlacklistId
number

The black list item ID

pstnBlacklistPhone
string

The phone number

PSTNBlacklistInterface

addPstnBlackListItem
(\n request: AddPstnBlackListItemRequest\n ) => Promise<AddPstnBlackListItemResponse>

[...]
